package whiteship;

import java.text.SimpleDateFormat;
import java.util.Date;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.propertyeditors.CustomDateEditor;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.WebDataBinder;
import org.springframework.web.bind.annotation.InitBinder;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

@Controller
@RequestMapping("/task/*")
public class TaskController {

	@Autowired
	TaskManager taskManager;

	@RequestMapping("/task/list.do")
	public void list(ModelMap model){
		model.addAttribute(taskManager.getAll());
	}

	@RequestMapping(method=RequestMethod.GET)
	public void add(ModelMap model){
		model.addAttribute(new Task());
	}

	@RequestMapping(method=RequestMethod.POST)
	public String add(@ModelAttribute("task") Task task){
		taskManager.add(task);
		return "redirect:/task/list.do";
	}

	@InitBinder
    public void initBinder(WebDataBinder binder) {
        SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
        dateFormat.setLenient(false);
        binder.registerCustomEditor(Date.class, new CustomDateEditor(dateFormat, false));
    }

}
